org.apache.poi.xssf.usermodel

## Class XSSFShape

- java.lang.Object
- - org.apache.poi.xssf.usermodel.XSSFShape

- All Implemented Interfaces:
    Shape
  Direct Known Subclasses:
    XSSFConnector, XSSFGraphicFrame, XSSFPicture, XSSFShapeGroup, XSSFSimpleShape

      public abstract class XSSFShape
      extends java.lang.Object
      implements Shape

  Represents a shape in a SpreadsheetML drawing.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected XSSFAnchor` | `anchor` anchor that is used by this shape
    `protected XSSFDrawing` | `drawing` Parent drawing
    `protected XSSFShapeGroup` | `parent` The parent shape, always not-null for shapes in groups

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `XSSFShape()`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `XSSFAnchor` | `getAnchor()`
    `XSSFDrawing` | `getDrawing()` Return the drawing that owns this shape
    `XSSFShapeGroup` | `getParent()`
    `protected abstract org.openxmlformats.schemas.drawingml.x2006.main.CTShapeProperties` | `getShapeProperties()` Returns xml bean with shape properties.
    `boolean` | `isNoFill()` Whether this shape is not filled with a color
    `void` | `setFillColor(int red, int green, int blue)` Sets the color used to fill this shape using the solid fill pattern.
    `void` | `setLineStyle(int lineStyle)` Sets the line style.
    `void` | `setLineStyleColor(int red, int green, int blue)` The color applied to the lines of this shape.
    `void` | `setLineWidth(double lineWidth)` Specifies the width to be used for the underline stroke.
    `void` | `setNoFill(boolean noFill)` Sets whether this shape is filled or transparent.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.apache.poi.ss.usermodel.Shape

      `getShapeName`

- - ### Field Detail

    - #### drawing

          protected XSSFDrawing drawing

      Parent drawing

    - #### parent

          protected XSSFShapeGroup parent

      The parent shape, always not-null for shapes in groups

    - #### anchor

          protected XSSFAnchor anchor

      anchor that is used by this shape

  - ### Constructor Detail

    - #### XSSFShape

          public XSSFShape()

  - ### Method Detail

    - #### getDrawing

          public XSSFDrawing getDrawing()

      Return the drawing that owns this shape
      Returns:
        the parent drawing that owns this shape

    - #### getParent

          public XSSFShapeGroup getParent()

      Specified by:
        `getParent` in interface `Shape`
      Returns:
        the parent shape.

    - #### getAnchor

          public XSSFAnchor getAnchor()

      Specified by:
        `getAnchor` in interface `Shape`
      Returns:
        the anchor that is used by this shape.

    - #### getShapeProperties

          protected abstract org.openxmlformats.schemas.drawingml.x2006.main.CTShapeProperties getShapeProperties()

      Returns xml bean with shape properties.
      Returns:
        xml bean with shape properties.

    - #### isNoFill

          public boolean isNoFill()

      Description copied from interface: `Shape`
      Whether this shape is not filled with a color
      Specified by:
        `isNoFill` in interface `Shape`
      Returns:
        true if this shape is not filled with a color.

    - #### setNoFill

          public void setNoFill(boolean noFill)

      Description copied from interface: `Shape`
      Sets whether this shape is filled or transparent.
      Specified by:
        `setNoFill` in interface `Shape`
      Parameters:
        `noFill` - if true then no fill will be applied to the shape element.

    - #### setFillColor

          public void setFillColor(int red,
                                   int green,
                                   int blue)

      Description copied from interface: `Shape`
      Sets the color used to fill this shape using the solid fill pattern.
      Specified by:
        `setFillColor` in interface `Shape`

    - #### setLineStyleColor

          public void setLineStyleColor(int red,
                                        int green,
                                        int blue)

      Description copied from interface: `Shape`
      The color applied to the lines of this shape.
      Specified by:
        `setLineStyleColor` in interface `Shape`

    - #### setLineWidth

          public void setLineWidth(double lineWidth)

      Specifies the width to be used for the underline stroke.
      Parameters:
        `lineWidth` - width in points

    - #### setLineStyle

          public void setLineStyle(int lineStyle)

      Sets the line style.
      Parameters:
        `lineStyle` -

Copyright 2020 The Apache Software Foundation or its licensors, as applicable.